#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum ScatterTemporalAggregation {
    #[serde(rename = "MEAN")]
    Mean,
    #[serde(rename = "MIN")]
    Min,
    #[serde(rename = "MAX")]
    Max,
    #[serde(rename = "FIRST")]
    First,
    #[serde(rename = "LAST")]
    Last,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl ScatterTemporalAggregation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            ScatterTemporalAggregation::Mean => "MEAN",
            ScatterTemporalAggregation::Min => "MIN",
            ScatterTemporalAggregation::Max => "MAX",
            ScatterTemporalAggregation::First => "FIRST",
            ScatterTemporalAggregation::Last => "LAST",
            ScatterTemporalAggregation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for ScatterTemporalAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for ScatterTemporalAggregation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for ScatterTemporalAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<ScatterTemporalAggregation, conjure_object::plain::ParseEnumError> {
        match v {
            "MEAN" => Ok(ScatterTemporalAggregation::Mean),
            "MIN" => Ok(ScatterTemporalAggregation::Min),
            "MAX" => Ok(ScatterTemporalAggregation::Max),
            "FIRST" => Ok(ScatterTemporalAggregation::First),
            "LAST" => Ok(ScatterTemporalAggregation::Last),
            v => v.parse().map(|v| ScatterTemporalAggregation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for ScatterTemporalAggregation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<ScatterTemporalAggregation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the ScatterTemporalAggregation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
